#!/usr/bin/env python
#
# Dan's script imacsMarkLines modifiied for ldss3 (simple arguement)

import COSMOS
from basics import *
from FITS import *


# Compatibility mode
argv,imacs2 = rdarg(argv,"--imacs2",None,0,single=1)

argv,imacs = rdarg(argv,"--imacs",None,0,single=1)
argv,moe = rdarg(argv,"--moe",None,0,single=1)

argv,ldss2 = rdarg(argv,"--ldss2",None,0,single=1)
argv,ldss3 = rdarg(argv,"--ldss3",None,0,single=1)

argv,trace = rdarg(argv,"-t",None,None)
argv,object = rdarg(argv,"-o",None,None)
argv,mapfile = rdarg(argv,"-m",None,None)
argv,(xb,yb) = rdarg(argv,"-b",lambda w: map(int,w.split("x")),"1x1")
argv,markid = rdarg(argv,"-id",None,0,single=1)
if not mapfile: raise "Error with mapfile!"

ll = argv[1]

if trace: trace = ravel(readtable(trace))

Mapping = COSMOS.Mapping(mapfile,trace=trace)
if object: Mapping.Recover(object)
else: [Mapping.Recover(object) for object in Mapping.objects]
objects = Mapping.objcache.keys()
print "Working on %d object(s)." % (len(objects))
#print objects
lw = readtable(ll)[0]

if ldss2 or ldss3: chips = 1
elif imacs or imacs2 or moe: chips = 8
co = [open("chip%d.lin" % (j),"w") for j in arange(chips)+1]

for object in objects:
#     print object
     o=Mapping.objcache[object]
     o.GetPixels(lw,usemid=(not markid))
     for j in range(len(o.w)):
        x,y = o.x[j]/xb,o.y[j]/yb
        x0,y0 = o.x0[j]/xb,o.y0[j]/yb
        x1,y1 = o.x1[j]/xb,o.y1[j]/yb
        if markid:
           if Mapping.xdisp:
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]), y0, x0, o.c[j]
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]), y,  x,  o.c[j]
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]), y1, x1, o.c[j]
           else:
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]), y0, x0,o.c[j]
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]),  y, x,o.c[j]
             print >> co[o.c[j]-1], "%s-%.0f" % (o["id"],o.w[j]), y1, x1,o.c[j]
        else:
           if Mapping.xdisp:
              print >> co[o.c[j]-1], "%.0fa" % (o.w[j]), y0,x0,o.c[j]
              print >> co[o.c[j]-1], "%.0fb" % (o.w[j]),  y, x,o.c[j]
              print >> co[o.c[j]-1], "%.0fc" % (o.w[j]), y1,x1,o.c[j]
           else:
              print >> co[o.c[j]-1], "%.0fa" % (o.w[j]),y0,x0,o.c[j]
              print >> co[o.c[j]-1], "%.0fb" % (o.w[j]), y, x,o.c[j]
              print >> co[o.c[j]-1], "%.0fc" % (o.w[j]),y1,x1,o.c[j]

[f.close() for f in co]


