from FITS import *
from sets import Set
import glob,os,pickle,sys


### aRedshift

### Binary list of redshift postscripts
def bin_list(direct,binary):
    bin = [int(j) for j in Set([l.replace(direct + "/","").split("_")[0]\
      for l in glob.glob(direct + "/*.bin")\
      if l.replace(direct + "/","") != binary])]
    bin.sort()
    return bin

### Binary dictionary 
def bin_dict(direct,binary,bin,objD,fitsfile):
    objB = {}
    Template={"credshift":None,"ccpeak":None,"cc":None,"chi2":None,"gobj":None,\
              "lnhd":None,"guess":None,"rederr1":None,"rederr2":None,"t":None,\
              "zrange":None,"matched":None,"bin":None,"comments":None,\
              "check":None}

    FITS1 = FITS(fitsfile)
    N = FITS1["n_slits"]

    if binary and os.path.exists(binary):
        objB = pickle.load(open(binary))
        for l in range(N):
            objB[l]["gobj"] = FITS1["obj%03d" % (l+1)]
            if [b for b in bin if b == l]:
                blist = [h for h in glob.glob(direct + "/%04d*.bin" % (l))\
                  if not pickle.load(open(h))["error"]]
                blist.sort()
                if blist: objB[l]["check"] = "ok"
                else: objB[l]["check"] = "fail"
            elif objD[l]["status"] == "skip": objB[l]["check"] = "skip"
            for td in Template:
                if not objB[l].has_key(td): objB[l][td] = Template[td]
    else:
        for l in range(N):
            objB[l]={"credshift":None,"ccpeak":None,"cc":None,"chi2":None,\
                     "gobj":FITS1["obj%03d" % (l+1)],"lnhd":None,"guess":None,\
                     "rederr1":None,"rederr2":None,"t":None,"zrange":None,\
                     "matched":None,"bin":None,"check":None}
        for l in range(N):
            if [b for b in bin if b == l]:
                blist = [h for h in glob.glob(direct + "/%04d*.bin" % (l))\
                  if not pickle.load(open(h))["error"]]
                blist.sort()
                if blist: objB[l]["check"] = "ok"
                else: objB[l]["check"] = "fail"
            elif objD[l]["status"] == "skip": objB[l]["check"] = "skip"

    # delete extra entries
    if len(objB) > N:
        for l in range(N,len(objB)): del objB[l]
    return objB

# aRedshift, aRedshiftDisplay, aRedshiftOutput, imacsDisplay

# Check dictionary
def dict_update(objD,dict,fitsfile):
    FITS1 = FITS(fitsfile)
    N = FITS1["n_slits"]
    fobjs = [FITS1["obj%03d" % (l+1)] for l in range(N)]
    FITS1.close()

    dictb = dict+".bkup"

    # backup original dictionary
    if not os.path.exists(dictb):
        f = open(dictb,"w")
        f.write(str(objD))
        f.close()

    # check time stamp between 1dspec and bin
    fft = os.path.getmtime(fitsfile)
    dt = os.path.getmtime(dict)
    new_objD = {}
    if fft > dt:
        # update inconsistant entries
        for j,k in enumerate(fobjs):
            new_objD[j] = {}
            new_objD[j]["object"] = k
            for l in objD:
                 o = objD[l]
                 if k == o["object"]:
                     new_objD[j] = o
    elif fft < dt:
        # update new object info
        for j,k in enumerate(fobjs):
            new_objD[j] = {}
            if objD.has_key(j): new_objD[j] = objD[j]
            new_objD[j]["object"] = k

    return new_objD




