#!/usr/bin/env python

import sys,glob,shutil,os

#temps = [adjustmap,alignmask,biasflat,extract2dspec,mapspectra,sflats,subskygalaxy,subskystar,\
#         sumspec]

#files = ["adjust-map.par","align-mask.par","biasflat.par","extract-2dspec.par",\
#        "map-spectra.par", "Sflats.par","subsky-galaxy.par","subsky-star.par"]

def help():
    print
    print "-c  --create                        create parameter files"
    print "-e  --edit    PARAMETER VALUE       edit parameter with new value"
    print "-f  --file    FILE PARAMETER VALUE  file edit parameter with new value"
    print "-h  --help                          print program options"
    print "-v  --view    PARAMETER             view parameter value"
    print

def SubImport(name):
    mod = __import__(name)
    components = name.split('.')
    for comp in components[1:]:
        mod = getattr(mod, comp)
    return mod

def getCosmospars(cosmos):
    if cosmos == "1-0":
        pname = "Cosmos1Parameters"
        import Cosmos1Parameters
    elif cosmos == "2-0":
        pname = "Cosmos2Parameters"
        import Cosmos2Parameters
    elif cosmos == "2-02":
        pname = "Cosmos202Parameters"
        import Cosmos202Parameters
    elif cosmos == "2-04":
        pname = "Cosmos204Parameters"
        import Cosmos204Parameters
    elif cosmos == "2-06":
        pname = "Cosmos206Parameters"
        import Cosmos206Parameters

    files = eval(pname+".files")
    cosmospars = {}
    [cosmospars.setdefault(f,eval(pname+"."+f.split(".")[0].replace("-","").lower())) for f in files]
    return cosmospars

def create(cosmos=0):
    cosmospars = getCosmospars(cosmos)
    for file in cosmospars:
        f=open(file,"w")
        f.write(cosmospars[file])
        f.close()

def edit(parameter,value,nobak,cosmos=0,files=None):
    cosmospars = getCosmospars(cosmos)
    if not files: files = cosmospars.keys()
    #print files,cosmos
    for file in files:
        par = open(file,"r").readlines()
        if not nobak: shutil.copyfile(file,file+".bak")
        cf = open(file,"w")
        for data in par:
            datalist = data.split(",")
            if parameter.lower() == datalist[0].lower(): 
                if datalist[1] is "i": datalist[3] = "%i" % (int(value))
                elif datalist[1] is "r": datalist[3] = "%.6f" % (float(value))
                elif datalist[1] in ("s","f"): datalist[3] = "\"%s\"" % (str(value))
                elif datalist[1] in "b": datalist[3] = "%s" % (str(value))
                ndatalist = ",".join(datalist)
                print file
                print ndatalist
                cf.write(ndatalist)    
            else: cf.write(data)
        cf.close()

def view(parameter,cosmos=0):
    cosmospars = getCosmospars(cosmos)
    for file in cosmospars:
        par = open(file,"r").readlines()
        for data in par:
            datalist = data.split(",")
            if parameter.lower() == datalist[0].lower(): 
                print file
                print datalist[0],datalist[3]
                print

nobak = 0
createtest = 0
edittest = 0
filetest = 0
viewtest = 0
cosmos = '2-06'

for n,arg in enumerate(sys.argv):
    if arg in ("-nb","--nobak"): nobak = 1
    elif arg in ("-c","--create"): createtest = 1
    elif arg in ("-1-0","--cosmos1-0"):  cosmos = '1-0'
    elif arg in ("-2-0","--cosmos2-0"):  cosmos = '2-0'
    elif arg in ("-2-02","--cosmos2-02"):  cosmos = '2-02'
    elif arg in ("-2-04","--cosmos2-04"):  cosmos = '2-04'
    elif arg in ("-2-06","--cosmos2-06"):  cosmos = '2-06'
    elif arg in ("-e","--edit"): 
        edittest = 1
        parameter = sys.argv[n+1]
        value = sys.argv[n+2]
    elif arg in ("-f","--file"): 
        filetest = 1
        files = [sys.argv[n+1]]
        parameter = sys.argv[n+2]
        value = sys.argv[n+3]
    elif arg in ("-v","--view"): 
        viewtest = 1
        parameter = sys.argv[n+1]
    elif arg in ("-h","--help"):
        help()
        sys.exit()

if createtest: create(cosmos=cosmos)
elif edittest: edit(parameter,value,nobak,cosmos=cosmos)
elif filetest: edit(parameter,value,nobak,cosmos=cosmos,files=files)
elif viewtest: view(parameter,cosmos=cosmos)
else:
    help()
    sys.exit()

