#!/usr/bin/env python
#
# This script separates the adjust-map'd file from HOLE's and SLIT's
#  
# e.g.
#     imacsSlitHole.py mask.SMF lamp.map

import sys

mask = sys.argv[1]
lamp = sys.argv[2]
smfread = open(mask,"r").readlines()
mapread = open(lamp,"r").readlines()
mapsplits = [l.split() for l in mapread]

holesmf = [l.split()[1] for l in smfread if "HOLE" in l.split()[0]]
slitsmf = [l.split()[1] for l in smfread if "SLIT" in l.split()[0]]
slit = [k for k,l in enumerate(mapread) if "SLIT" in l]
end = [k for k,l in enumerate(mapread) if "END" in l]
slit.append(end[0])

holepos = [(k,slit[n+1]) for obj in holesmf for n,k in enumerate(slit) if len(mapsplits[k])>2 and obj == mapsplits[k][2]]
slitpos = [(k,slit[n+1]) for obj in slitsmf for n,k in enumerate(slit) if len(mapsplits[k])>2 and obj == mapsplits[k][2]]

lampname = lamp.replace(".map","")

fhole = open("%s_hole.map" % (lampname),"w")
[fhole.write(mapread[n]) for n in range(0,6)]
[fhole.write(mapread[i]) for j,k in holepos for i in range(j,k)]
fhole.write("END")
fhole.close()

fslit = open("%s_slit.map" % (lampname),"w")
[fslit.write(mapread[n]) for n in range(0,6)]
[fslit.write(mapread[i]) for j,k in slitpos for i in range(j,k)]
fslit.write("END")
fslit.close()
