#!/usr/bin/env python
#
#             obsdef      dewoff           +/- increments
# longslit.py --obsdef SMC1.obsdef --amplitude 5.0 --increment 0.5
### longslit.py SMC1.obsdef LC300l_NS.dewoff 5.0 0.5

import os,sys
from Numeric import *

def obsdef(obs):
    obsD = {}
    obsL = open(obs,"r").readlines()
    for l in obsL:
        t = l.split()
        # 1st column key, 2nd column value
        obsD[t[0]]=t[1]
    return obsD

def dewoff(dew):
    dewD = {}
    dewL = open(dew,"r").readlines()
    for l in dewL:
        if l[0] == "#" and len(l) > 1: 
            dewD["HEAD"] = l
        elif l[0] != "#":
            t = l.split()
            # ROT, SCALE, DX, DY
            dewD["ROT"] = t[0]
            dewD["SCALE"] = t[1]
            dewD["DX"] = t[2]
            dewD["DY"] = t[3]
    return dewD

#def iterate(obs,dew,obsD,dewD,N,n):
def iterate(obs,obsD,N,i,ll,bin):
    gra = float(obsD["GR_ANGLE"])
    rotl =  arange(-N+gra,N+gra+i,i)
    #print rotl
    #rotlc = compress(greater(rotl,0),rotl)
    ### APPEARS TO BE BUG WITH COSMOS AND GRATING ANGLES LESS THAN 1.00
    rotlc = compress(greater(rotl,1),rotl)
    #print rotlc
    obspre = obs.replace(".obsdef","")
    #dewpre = dew.replace(".dewoff","")
    #sys.exit()
    for j,r in enumerate(rotlc):
        #dewfile = "%s-%i.dewoff" % (dewpre,j)
        #obsD["DEWOFF"] = dewfile.replace(".dewoff","")
        obsD["GR_ANGLE"] = "%-7.3f" % (r)
        obsinfo = "\n".join(["%-16s%s" % (d,obsD[d]) for d in obsD])
        print obsinfo
        f = open("%s-%i.obsdef" % (obspre,j),"w")
        f.write(obsinfo)
        f.close()
        #os.system("adjust-offset %s 0 0 %7.3f 1" % (dewpre,r))
        #os.system("mv %s %s-%i.dewoff" % (dew,dewpre,j))
        #os.system("".join(["mv %s" % (dew),"% ","%s" % (dew)]))
        os.system("map-spectra %s-%i" % (obspre,j))
        os.system("CosmosMarkLines.py -m %s-%i.map -id %s --imacs -b %s" % (obspre,j,ll,bin)) ### NEED TO ADD BINNING OPTION, ADD BINNING TO DATABASE
        [os.system("mv chip%i.lin chip%i-%i.lin" % (k,k,j)) for k in 1+arange(8)] 

ll = "HeNeAr.dat"
n = 0 

for arg in sys.argv:
    if arg in ("-o","--obsdef"): obs = sys.argv[n+1]
    elif arg in ("-a","--amplitude"): N = float(sys.argv[n+1])
    elif arg in ("-a","--binning"): bin = sys.argv[n+1]
    elif arg in ("-i","--increment"): i = float(sys.argv[n+1])
    elif arg in ("-l","--linelist"): ll = sys.argv[n+1]
    n += 1
 
#dew = sys.argv[2]


#iterate(obs,dew,obsdef(obs),dewoff(dew),N,n)
iterate(obs,obsdef(obs),N,i,ll,bin)


