#!/usr/bin/env python
#
# MIKE Pipeline Cheetah Report
#
#
# Last modified 7-1-05

#import glob, os, sys, getpass

from Cheetah.Template import Template
from timestamp import timestamp
from mikeTools import *
from mikeCheetahTools import *
import glob

### Cheetah MIKE Report
def cheetahpipe():
    n = 0
    k = 0

    adj = "\n"
    obj = "pipeline"
    #searchslit = "*slit*f.fits"
    #searchlamp = "*lamp*fs.fits"
    searchlamp = "lamp*.fits"

    condition = ["stage-overscan:","stage-flatten:","stage-defringe:","stage-ydist-copy:",\
                 "stage-orders-copy:","stage-deslitfn:","stage-xdist:","stage-xdist-copy:",\
                 "stage-wdist:","stage-wdist-copy:","stage-wdist-offset:","stage-skyaps:",\
                 "stage-skyrect:","stage-skysub:","stage-objaps:","stage-extractall:",\
                 "stage-finalize:"]

    ### 2 spaces are needed after the correction in order to display the correction properly
    correction = ["","","","Copying the Order Curvature  ","","","Line Curvature  ",\
                  "Copying the Line Curvature  ","","Copy the Wavelength Calibration  ",\
                  "Wavelength Calibration Offset  ","","","","","Run Gauss-Hermite Legendre B-spline Extraction  ",""]

    #conditionlist = ["overscan","flatten","ydist_copy","orders_copy","deslitfn",\
    #        "xdist","xdist_copy","wdist","skyaps","skyrect","skysub","objaps","extractall",\
    #        "finalize"]
    #condition = ["stage-overscan:","stage-flatten:","stage-ydist-copy:",\
    #             "stage-orders-copy:","stage-deslitfn:",\
    #             "stage-xdist:","stage-xdist-copy:","stage-wdist:","stage-skyaps:",\
    #             "stage-skyrect:","stage-skysub:","stage-objaps:","stage-extractall:",\
    #             "stage-finalize:"]
    #### 2 spaces are needed after the correction in order to display the correction properly
    #correction = ["","","Copying the Order Curvature  ","","",\
    #              "Line Curvature  ","Copying the Line Curvature  ","","","","","","",""]
    tests = os.path.isfile(glob.glob("*.pipeline")[0])
    if tests is False:
        print "%s file not found" % (objsearch)
        return obj,tests 
    #testfringe = os.path.isfile("fringe.fits")
    #if testfringe is True:
        #searchslit = "*slit*ff.fits"
        #searchlamp = "*lamp*ffs.fits"
    pipefile = open(glob.glob("*.pipeline")[0])
    pipelist = pipefile.readlines()

    corcond = [(cond,correction[condition.index(cond)]) for cond in condition if cond in join(pipelist)]
    condition = [c[0] for c in corcond]
    correction = [c[1] for c in corcond]


    #for q,cond in enumerate(condition):
    #    ctest = False
    #    for pipeline in pipelist:
    #        if cond in pipeline: ctest = True
    #    if ctest is False:
    #        #print cond
    #        condition.remove(cond)
    #        del correction[q]

    cheetahstr = ""
    for pipeline in pipelist:
        #cheetahdict[conditionlist[n]]= ""
        if condition[n] in pipeline:
            print condition[n]
            #print conditionlist[n]
            print correction[n]
            line,test = check((pipelist[k+1])[2:],condition[n],correction[n])
            cheetahstr = cheetahstr + adj + "<P><B><I>%s</I></B></P>" % (line)
            if test is True:
                #if "stage-ydist:" in pipeline:
                #    cheetahstr = cheetahstr + adj + table2col([0,6,"Frame","Scatter About the Fit","<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n",\
                #                                                    "<TR><TD>%s<TD>%4.2f pixels\n"],headread(["Y0XFMR",searchslit]))
                #elif "stage-orders:" in pipeline:
                #    cheetahstr = cheetahstr + adj + table2col([0,6,"Frame","Number of Slits","<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n","<TR><TD>%s<TD>%i\n"],\
                #                                                    headread(["NSLITS",searchslit]))
                #    cheetahstr = cheetahstr + adj + image3col(["Quadratic Fit to Order Locations",6,200,200],"jpg/*orders.jpg")
                if "stage-xdist:" in pipeline:
                    cheetahstr = cheetahstr + adj + image1col(["Global Fit to Rectifications",6,200,500],"jpg/*glob.jpg")
                elif "stage-wdist:" in pipeline:
                    cheetahstr = cheetahstr + adj + table3colmulti([0,6,"Frame","Spectral Order Numbers","Scatter in &lambda;-Calibration",\
                                                                         "<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n","<TR><TD>%s<TD>%i-%i<TD>%7.5f pixels\n"],\
                                                                         headreadN(["ECORD",searchlamp,1],headreadS(["NSLITS",searchlamp])),\
                                                                         headread(["ECORD0",searchlamp]),headread(["E0XFMR",searchlamp]))
                    cheetahstr = cheetahstr + adj + image3col(["Cross Correlations for Order Number Identification",6,200,200],"jpg/*MatchOrder.jpg")
                    cheetahstr = cheetahstr + adj + image1col(["Residuals from Wavelength Solution",6,475,475],"jpg/*histo.jpg")
                elif "stage-skyaps:" in pipeline:
                    cheetahstr = cheetahstr + adj + image1col(["Object Positioning for Sky Apertures",6,400,400],"jpg/*apspos.jpg")
                elif "stage-objaps:" in pipeline:
                    cheetahstr = cheetahstr + adj + image1col(["Object Positioning for Extraction Apertures",6,400,400],"jpg/*skypos.jpg")
                elif "stage-extractall:" in pipeline:
                    cheetahstr = cheetahstr + adj + image1col([0,6,225,315],"jpg/*ms2n.jpg")
            n += 1
        if n > (len(condition) - 1):
            break
        k += 1
    cheetahdict["checks"]= cheetahstr

    #for pipeline in pipelist:
    #    #cheetahdict[conditionlist[n]]= ""
    #    if condition[n] in pipeline:
    #        print condition[n]
    #        print conditionlist[n]
    #        print correction[n]
    #        line,test = check((pipelist[k+1])[2:],condition[n],correction[n])
    #        cheetahdict[conditionlist[n]]= "<P><B><I>%s</I></B></P>" % (line)
    #        if test is True:
    #            #if "stage-ydist:" in pipeline:
    #            #    cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + table2col([0,6,"Frame","Scatter About the Fit","<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n",\
    #            #                                                    "<TR><TD>%s<TD>%4.2f pixels\n"],headread(["Y0XFMR",searchslit]))
    #            #elif "stage-orders:" in pipeline:
    #            #    cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + table2col([0,6,"Frame","Number of Slits","<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n","<TR><TD>%s<TD>%i\n"],\
    #            #                                                    headread(["NSLITS",searchslit]))
    #            #    cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image3col(["Quadratic Fit to Order Locations",6,200,200],"jpg/*orders.jpg")
    #            if "stage-xdist:" in pipeline:
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image1col(["Global Fit to Rectifications",6,200,500],"jpg/*glob.jpg")
    #            elif "stage-wdist:" in pipeline:
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + table3colmulti([0,6,"Frame","Spectral Order Numbers","Scatter in &lambda;-Calibration",\
    #                                                                     "<TR><TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s<TH ALIGN=LEFT>%s\n","<TR><TD>%s<TD>%i-%i<TD>%7.5f pixels\n"],\
    #                                                                     headreadN(["ECORD",searchlamp,1],headreadS(["NSLITS",searchlamp])),\
    #                                                                     headread(["ECORD0",searchlamp]),headread(["E0XFMR",searchlamp]))
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image3col(["Cross Correlations for Order Number Identification",6,200,200],"jpg/*MatchOrder.jpg")
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image1col(["Residuals from Wavelength Solution",6,475,475],"jpg/*histo.jpg")
    #            elif "stage-skyaps:" in pipeline:
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image1col(["Object Positioning for Sky Apertures",6,400,400],"jpg/*apspos.jpg")
    #            elif "stage-objaps:" in pipeline:
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image1col(["Object Positioning for Extraction Apertures",6,400,400],"jpg/*skypos.jpg")
    #            elif "stage-extractall:" in pipeline:
    #                cheetahdict[conditionlist[n]] = cheetahdict[conditionlist[n]] + adj + image1col([0,6,225,315],"jpg/*ms2n.jpg")
    #        n += 1
    #    if n > (len(condition) - 1):
    #        break
    #    k += 1

def cheetahvar(namespace):
    #templateDef = """
    #<HTML>
    #<HEAD><TITLE>$title</TITLE></HEAD>
    #<BODY>
    #  <P>$header</P>
    #  <P>$links</P>
    #
    #  $exp
    #  $frames
    #  $overscan
    #  $flatten
    #  $ydist_copy
    #  $orders_copy
    #  $deslitfn
    #  $xdist
    #  $xdist_copy
    #  $wdist
    #  $skyaps
    #  $skyrect
    #  $skysub
    #  $objaps
    #  $extractall
    #  $finalize
    #
    #</BODY>
    #</HTML>"""
    
    templateDef = """
    <HTML>
    <HEAD><TITLE>$title</TITLE></HEAD>
    <BODY>
      <P>$header</P>
      <P>$links</P>
    
      $exp
      $frames
      $checks
    
    </BODY>
    </HTML>"""

    t = Template(templateDef,searchList=[namespace])
    t.title = "MIKE Pipeline Report for %s" % (target())
    t.header = "Generated by %s at %s" % (user(),timestamp())
    short = glob.glob("*_reportShort.pdf")[0]
    long = glob.glob("*_reportLong.pdf")[0]
    multi = glob.glob("*_multi.fits")[0]
    t.links = "Download fits multi: <a href='%s'>%s</a><BR>Download pdf short report: <a href='%s'>%s</a><BR>Download pdf long report: <a href='%s'>%s</a><BR>" % (multi.replace("+","_"),multi,short.replace("+","_"),short,long.replace("+","_"),long)
    t.exp = "<P>Total Effective Exposure: %r</P>" % (exptime())
    #t.frames = "<P>Science Frames:<BR>%s</P><P>Th Ar Frames:<BR>%s</P><P>Quartz Frames:<BR>%s</P>" % (frames())
    t.frames = "<P>Science Frames:<BR>%s</P><P>Th Ar Frames:<BR>%s</P>" % (frames())
    content = t.respond()
    print t 

    f = open("index.html","w")
    f.write(content)
    f.close()

def gocheetah():
    global cheetahdict
    cheetahdict = {}
    cheetahpipe()
    cheetahvar(cheetahdict)

#gocheetah()
