#!/usr/bin/env python
#
# Last modified 11-16-04
#
# Goal - to modify mikeCheetahTools such that any information can be imported!
# 
# TODO:
# Create generic tools for both ReportLab and Cheetah?
# Fix image headers (such that they are not separate from the images).
# Create helper functions of repeated commands.
# Add new conditions for image head.

import glob, os, sys

### Tables 
def table2col(tableinfo,tabledict):
    caption,space,head1,head2,headtype,datatype = tableinfo
    keylist = tabledict.keys()
    valuelist = tabledict.values()
    indent = " "*space
    tablehead = indent + "<P><TABLE BORDER=1>\n"
    tabletail = indent + "</TABLE></P>"
    tablebody = ""

    if caption is 0: tabletitle = ""
    else: tabletitle = indent + "<CAPTION>%s</CAPTION>\n" % (caption)
    if head1 is 0 and head2 is 0 and headtype is 0: tablepara = ""
    else: tablepara = indent + headtype % (head1,head2)

    for i in range(len(keylist)): tablebody = tablebody + indent + datatype % (keylist[i],valuelist[i])

    table = tablehead + tabletitle + tablepara + tablebody + tabletail    
    return table

def table3colmulti(tableinfo,table1dict,table2dict,table3dict):
    caption,space,head1,head2,head3,headtype,datatype = tableinfo
    keylist1 = table1dict.keys()
    valuelist1 = table1dict.values()
    valuelist2 = table2dict.values()
    valuelist3 = table3dict.values()
    indent = " "*space
    tablehead = indent + "<P><TABLE BORDER=1>\n"
    tabletail = indent + "</TABLE></P>"
    tablebody = ""

    if caption is 0: tabletitle = ""
    else: tabletitle = indent + "<CAPTION>%s</CAPTION>\n" % (caption)
    if head1 is 0 and head2 is 0 and head3 is 0 and headtype is 0: tablepara = ""
    else: tablepara = indent + headtype % (head1,head2,head3)

    for i in range(len(keylist1)): tablebody = tablebody + indent + datatype % (keylist1[i],valuelist1[i],valuelist2[i],valuelist3[i])

    table = tablehead + tabletitle + tablepara + tablebody + tabletail    
    return table

### Images
def image1col(imageinfo,imagesearch):
    caption,space,height,width = imageinfo
    indent = " "*space
    imagelist = glob.glob(imagesearch)
    imagehead = indent + "<P><TABLE BORDER=0>\n"
    imagetail = indent + "</TABLE></P>"
    imagebody = ""

    if caption is 0: imagetitle = ""
    else: imagetitle = indent + "<CAPTION>%s</CAPTION>\n" % (caption)

    n = 0
    k = 0
    for image in imagelist:
        image = image.replace("+","_")
        imagebody = imagebody + indent + "<TR><TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>\n" % (height,width,image)

    print imagebody
    imagetable = imagehead + imagetitle + imagebody + imagetail    
    return imagetable

def image2col(imageinfo,imagesearch):
    caption,space,height,width = imageinfo
    indent = " "*space
    imagelist = glob.glob(imagesearch)
    imagehead = indent + "<P><TABLE BORDER=0>\n"
    imagetail = indent + "</TABLE></P>"
    imagebody = ""

    if caption is 0: imagetitle = ""
    else: imagetitle = indent + "<CAPTION>%s</CAPTION>\n" % (caption)

    n = 0
    k = 0
    for image in imagelist:
        image = image.replace("+","_")
        if k is 0:
            imagebody = imagebody + indent + "<TR><TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>" % (height,width,image)
            if n is len(imagelist)-1:
                imagebody = imagebody + "\n" 
                break
            else: k += 1
        elif k is 1:
            imagebody = imagebody + "<TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>\n" % (height,width,image)
            if n is len(imagelist) - 1: break
            else: k = 0 
        n += 1

    print imagebody
    imagetable = imagehead + imagetitle + imagebody + imagetail    
    return imagetable

def image3col(imageinfo,imagesearch):
    caption,space,height,width = imageinfo
    indent = " "*space
    imagelist = glob.glob(imagesearch)
    imagehead = indent + "<P><TABLE BORDER=0>\n"
    imagetail = indent + "</TABLE></P>"
    imagebody = ""

    if caption is 0: imagetitle = ""
    else: imagetitle = indent + "<CAPTION>%s</CAPTION>\n" % (caption)

    n = 0
    k = 0
    for image in imagelist:
        image = image.replace("+","_")
        if k is 0:
            imagebody = imagebody + indent + "<TR><TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>" % (height,width,image)
            if n is len(imagelist)-1:
                imagebody = imagebody + "\n" 
                break
            else: k += 1
        elif k is 1:
            imagebody = imagebody + "<TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>" % (height,width,image)
            if n is len(imagelist) - 1:
                imagebody = imagebody + "\n" 
                break
            else: k += 1
        elif k is 2: 
            imagebody = imagebody + "<TD><IMG HEIGHT='%i' WIDTH='%i' SRC='%s'>\n" % (height,width,image)
            if n is len(imagelist) - 1: break
            else: k = 0 
        n += 1

    print imagebody
    imagetable = imagehead + imagetitle + imagebody + imagetail    
    return imagetable

