#!/usr/bin/env python
# 
# Python program that takes all of the output postscript files from
# the MIKE Pipeline and converts them to jpg so they can be inserted
# into ReportLab.
#
# Last modified 10-26-04

import os,glob,shutil

def convert():
    try:
        os.listdir("jpg")
        print "previous jpg directory found!"
        shutil.rmtree("jpg")
        print "removing previous jpg directory!"
    except:
        print "no jpg directory found!"
    os.mkdir("jpg")
    print "creating new jpg directory!"   
    pslist = glob.glob("*.ps")

# Dan's code!
#    suffices = ["histo","glob","MatchOrder","ms2n","orders","apspos","skypos"]
#    geometries = ["965x937","1219x371","573x456","667x421","1029x862","1154x969","1154x969"]
#    rotates = [1,0,0,0,0,0,0]
#    psconv = lambda psfile,geometry,rotate: "convert -density 300x300 %s -blur 1x1 -geometry %s -quality 25 %s jpg/%s" % (["","-rotate 90"][rotate],geometry,psfile, psfile.replace(".ps",".jpg"))
#    psconvs = [psconv(psfile,geometries[suffices.index(suffix)],rotates[suffices.index(suffix)]) for suffix in suffices for psfile in glob.glob("*%s.ps" % (suffix))]
#    psselectpage = lambda psfile,page: psfile.replace("match.ps","match_%02d.ps" % (page))
#    psselect = lambda psfile,page: "psselect -p%02d %s %s; %s; rm %s" % (page, psfile, psselectpage(psfile,page), psconv(psselectpage(psfile,page),"1144x1000",1), psselectpage(psfile,page))
#    psselects = [psselect(psfile,page) for psfile in glob.glob("*match.ps") for page in range(1,1+int(open(psfile,"r").readlines()[-2].split()[1]))]
#    [os.system(psconv) for psconv in psconvs]
#    [os.system(psselect) for psselect in psselects]

    for psfile in pslist:
        if "match.ps" in psfile:
            pages = int(open(psfile).readlines()[-2].split()[1])
            for page in range(1,1+pages):
                psfilepage = psfile.replace("match.ps","match_%02d.ps" % (page))
                os.system("psselect -p%02d %s %s" % (page, psfile, psfilepage))
                # Note! There is a problem with rotation if the *_??.ps files
                # are not removed!!!
                os.system("convert -density 300x300 -rotate 90 -blur 1x1 -geometry 1144x1000 -quality 25 %s jpg/%s" % (psfilepage, psfilepage.replace(".ps",".jpg")))
        elif "histo.ps" in psfile:
            os.system("convert -density 300x300 -rotate 90 -blur 1x1 -geometry 965x937 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "glob.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 1219x371 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "MatchOrder.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 573x456 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "ms2n.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 667x421 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "orders.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 1029x862 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "apspos.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 1154x969 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))
        elif "skypos.ps" in psfile:
            os.system("convert -density 300x300 -blur 1x1 -geometry 1154x969 -quality 25 %s jpg/%s" % (psfile, psfile.replace(".ps",".jpg")))

    os.system("rm *match_[0-9][0-9].ps")
    print "removing extra postscripts"

#convert()
