#!/usr/bin/env python
#
# Script that checks for errors in MIKE Pipeline.
#
# Last modified 12-7-04

## Test directories:
## /data1/mifune/kelson/MIKE/PipelineData/ian/jfaug04

import os,glob,sys,string,re
from types import *

def help():
    print
    print '-c  --count                 counts the number of errors'
    print '-d  --dir                   directories of failures'  
    print '-e  --error    ERRORSTR     string searches for specific error'
    print '-h  --help                  displays help'
    print '-p  --prefix   "PREFIXSTR"  string searches PREFIXSTR/*.out'
    print '-s  --summary               summary of the errors'
    print
    print 'e.g.'
    print 'mikeError.py -p "*/*"'
    print 'searches "*/*/*.out"'
    print

def uberprint(printbuffer):
    j = 0 
    for buffer in printbuffer:
        j += 1
        for line in buffer:
            print line

        print
    return j

def errorsummary(uberbuffer,searchpath):
    errorbuffer = {}
    for buffer in uberbuffer:
        for line in buffer:

            if "make[1]: *** [stage-" in line:
                #print line

                if len(errorbuffer) is 0:
                    errorbuffer[line] = 1
                else:
                    errorcheck = None 
                    for n in range(0,len(errorbuffer)):
                        error = errorbuffer.keys()[n]
                        if error in line:
                            errorcheck = n
                    #print len(errorbuffer)
                    #print range(0,len(errorbuffer))
                    if errorcheck is not None:
                        errorvalue = errorbuffer.values()[errorcheck]
                        errorbuffer[line] = errorvalue + 1
                    elif errorcheck is None:
                        errorbuffer[line] = 1
                #print errorbuffer
                #print

    print "Search path:",searchpath
    #print errorbuffer
    for n in range(0,len(errorbuffer)):
        #print "%-30s %i" % (errorbuffer.keys()[n] + " errors:",errorbuffer.values()[n])
        super = errorbuffer.keys()[n] 
        print "%s %i" % (super[re.search("stage-",super).start():].split(']')[0] + " errors:",errorbuffer.values()[n])
    return 

def errorsearch(serror,count,summary,prefix,dir):
    searchpath = "%s/*.out*" % (prefix)
    outpathlist = glob.glob(searchpath) 
    k = len(outpathlist)
    outpathlist.sort()
    outlist = []
    fnloutlist = []
    prefixbkup = ""
    n = 0
   
    for outpath in outpathlist:
        out = os.path.basename(outpath)
        prefix = os.path.dirname(outpath)
        if prefixbkup not in prefix: 
            fnloutlist.append(outlist[len(outlist)-1])
            outlist = []
        outlist.append(outpath)
        if n is k - 1:
            fnloutlist.append(outlist[len(outlist)-1])
        prefixbkup = prefix
        n += 1
    buffer = []
    uberbuffer = []
    dirbuffer = []
    cont = False
    for out in fnloutlist:
        outfile = open(out).readlines()
        for outline in outfile:
            outline = outline.rstrip()
            if cont is False:
                if "Error" in outline or "Traceback" in outline or "Command not found" in outline:
                    cont = True
                    buffer.append(out)
                    buffer.append(outline)
                    if dir: dirbuffer.append(out)

            elif cont is True:
                buffer.append(outline)
                if "make[1]: Leaving directory" in outline: 
                    cont = False
                    uberbuffer.append(buffer)
                    buffer = []

    if dir and not summary: 
        print "Directories:"
        for d in dirbuffer: print d
        print
        sys.exit()

    printbuffer = []

    if serror is not None:
        for buffer in uberbuffer:
            for line in buffer:
                if serror in line:  
                    printbuffer.append(buffer)
                    
    elif serror is None:
        printbuffer = uberbuffer

    j = uberprint(printbuffer)

    if summary is True:
        errorsummary(uberbuffer,searchpath)

    if count is True:
        print "Total errors: %i" % (j)

    if dir and summary:
        print "\nDirectories:"
        for d in dirbuffer: print d
    print


n = 0
prefix = "*"
serror = None 
count = False
summary = False
dir = False
for arg in sys.argv:
    if arg in ("-e","--error"): serror = sys.argv[n+1]
    elif arg in ("-c","--count"): count = True
    elif arg in ("-d","--dir"): dir = True
    elif arg in ("-s","--summary"): summary = True
    elif arg in ("-p","--prefix"): prefix = sys.argv[n+1]
    elif arg in ("-h","--help"):
        help()
        sys.exit()
    n += 1

print 
errorsearch(serror,count,summary,prefix,dir)
