#!/usr/bin/env python
#
# Last modified 11-10-04

from FITS import *
from basics import *
from pgplot import *

import glob
def ms2nplot():
    try:
        fitsfile = glob.glob("*_multi.fits")[0]
    except IndexError:
        print "*_multi.fits file not found"
        return 0
    f = FITS(fitsfile)
    data = f.data()
    s2n = data[3]
    s2n25,s2n50,s2n75=quartiles(transpose(s2n))
    orders = array([int(f["ecord%d" % (j)]) for j in range(s2n.shape[0])])
    f.close()

    # Plot of ms2n vs orders

    opendev("%sms2n.ps/vcps" % (fitsfile[:-5]),nx=1,ny=1,land=0,size=5,asp=0.6)
    ym = [0,1.5*max(s2n50)]
    newbox(extrema(orders), ym,ch=2.0)
    drawln(orders,s2n25,ls=4,ci=2,lw=4)
    drawln(orders,s2n50,ls=2,ci=4,lw=4)
    drawln(orders,s2n75,ls=4,ci=2,lw=4)
    xlabel("Order",ch=2.0)
    ylabel("S/N Ratio (per pixel)",ch=2.0)
    subtitle("25th, 50th, and 75th Percentiles",ch=2.0)
    closedev()

#ms2nplot()
