#!/usr/bin/env python

from FITS import *
from pgplot import *
from basics import *
import sys

def specplot(j,name,w,spec,title):
    object,noise = spec
    newbox([w[0],w[len(w)-1]],extrema(object),ch=2)
    #if title and k in range(0,spec.shape[1],4): wrttext("",title,1.0,1.5,0.0,"T",1,0,1)
    if title and j is 0: wrttext("",title,1.0,2.0,0.0,"T",1,0,1)
    drawln(w,object)
    xlabel("wavelength (\A)",ch=2)
    ylabel("counts",ch=2)
    wrttext("","obj%03d" % (j+1),-2.0,2.0,0.75,"T",1,0,1)
    wrttext("",name,-3.0,2.0,0.75,"T",1,0,1)
    
argv,key = rdarg(argv,"-k",None,None)
argv,title = rdarg(argv,"-t",None,None)
opendev("%s.ps/cps" % (argv[1].replace(".fits","")),nx=4,ny=4,land=0,size=10,asp=0.8)
f = FITS(argv[1]); spec = f.data()
x = 1+arange(f["naxis1"])
w = (x - f["crpix1"])*f["cdelt1"]+f["crval1"]
if f["deflag"] is 1: w = power(10,w)
objid = [f["obj%03d" % (j+1)] for j in range(spec.shape[1])]
[specplot(j,objid[j],w,spec[::,j,::],title) for j in range(spec.shape[1]) if (key and key in objid[j]) or not key]
f.close()
closedev()
